package net.larsan.test.jetty;

import java.io.IOException;

import javax.servlet.http.HttpServletRequest;

import org.apache.log4j.Logger;
import org.eclipse.jetty.websocket.WebSocket;
import org.eclipse.jetty.websocket.WebSocket.OnTextMessage;
import org.eclipse.jetty.websocket.WebSocketServlet;

/*
 * This is a simple web socket servlet that only echoes
 * string messages back to the sender. 
 */
public class EchoSocketServlet extends WebSocketServlet {
	
	private final Logger log = Logger.getLogger(getClass());

	private static final long serialVersionUID = 4754835610402258588L;

	public WebSocket doWebSocketConnect(HttpServletRequest request, String protocol) {
		return new Socket();
	}
	
	
	private class Socket implements WebSocket, OnTextMessage {
		
		private Connection connection;

		public void onClose(int closeCode, String message) { 
			log.info("Jetty connection closed");
		}
		
		public void onMessage(String data) {
			try {
				// Echo data right back
				connection.sendMessage(data);
			} catch (IOException e) {
				log.error("Failed to send message", e);
			}
		}
		
		public void onOpen(Connection connection) {
			log.info("Jetty connection opened");
			this.connection = connection; 
		}
	}
}
